/******************************************************************************/
/* Agent2b - Vending Machine                                                  */
/******************************************************************************/
/* Nome: 8645_VMNSTP_Cancela_Abastecimento                                    */
/*                                                                            */
/* Descrio:                                                                 */
/*  Cancela o abastecimento do veculo                                        */
/*                                                                            */
/* Criao:                                                                   */
/* 18/07/2003 - Luciana Correa                                                */
/******************************************************************************/
/* raise_application_error(-20501, '' , True);                                */
/* @C:\Win_V2\Sql\End_Conv\Oracle\8645_VMNSTP_Cancela_Abastecimento.SQL       */
/******************************************************************************/
CREATE OR REPLACE PROCEDURE CANCELA_ABASTECIMENTO
   (P_IDTIPOTRANSF IN  TIPORETI.CDTIPORETI%TYPE,
    P_IDTIPOEQUIPA IN  MAPABASEV.IDSITMAPABAS%TYPE,
    P_PRXLANCESTQ  IN  LANCTOESTOQ.NRLANCESTQ%TYPE,
    P_CDFILIALMAP  IN  MAPABASEV.CDFILIAL%TYPE,
    P_NRMAPABASEV  IN  MAPABASEV.NRMAPABASEV%TYPE,
    P_DTMAPABASEV  IN  MAPABASEV.DTMAPABASEV%TYPE,
    P_NRVENDA      IN  VENDAVMN.NRVENDA%TYPE,
    P_CDFILIAL     IN  FILIAL.CDFILIAL%TYPE,
    P_CDALMOXARIFE IN  PARAMFILIAL.CDALMOXARIFE%TYPE,
    P_CDLOCALESTOQ IN  PARAMFILIAL.CDLOCALESTOQ%TYPE,
    P_CDOPERADOR   IN  OPERADOR.CDOPERADOR%TYPE,
    P_CDFILIORIG   IN  FILIAL.CDFILIAL%TYPE DEFAULT ' ',
    P_CDALMOXORIG  IN  PARAMFILIAL.CDALMOXARIFE%TYPE DEFAULT ' ',
    P_CDLOCALORIG  IN  PARAMFILIAL.CDLOCALESTOQ%TYPE DEFAULT ' ')
IS
   V_CDFILIPROC   PARAMGERAL.CDFILIAL%TYPE;
   V_IDTPLANCTO   LANCTOESTOQ.IDTPLANCTO%TYPE;
   V_IDENTRSAIDOP LANCTOESTOQ.IDENTRSAIDOP%TYPE;
   V_CDTIPORETI   ITLANCTOEST.CDTIPORETI%TYPE;
   V_CDTIPORETIDE PARGERALVMN.CDTIPORETIDE%TYPE;
   V_CDTIPOOPER   LANCTOESTOQ.CDTIPOOPER%TYPE;
   V_IDLESTRECMAP LANCESTRECMA.IDLESTRECMAP%TYPE;
   V_DTFINAL      MAPABASEV.DTMAPABASEV%TYPE;
   V_IDTIPOMOVI   ITLANCTOEST.IDTIPOMOVI%TYPE;
   V_IDGERAITEM   ITLANCTOEST.IDTIPOMOVI%TYPE;

   V_NRSEQITEM    NUMBER;
   V_QTPRODVEND   NUMBER;
   V_CTITELANCTO  NUMBER;
   V_VRCUSTOPROD  NUMBER;
   V_QTVENDGRANDT NUMBER;
   V_VRVENDGRANDT NUMBER;
BEGIN
/* P_IDTIPOTRANSF:
  - SA: Sada para Abastecimento -> Almox. Rota
  - EA: Entrada de Abastecimento -> Almox. Mquina
  - SR: Sada de Retirada        -> Almox. Mquina
  - ER: Entrada de Retirada      -> Almox. Site (ParamFilial)
*/
   IF (P_IDTIPOTRANSF = 'EA') OR (P_IDTIPOTRANSF = 'ER') THEN
      V_IDTPLANCTO   := '2';
      V_IDENTRSAIDOP := 'E';
      V_IDTIPOMOVI   := '2';
   ELSE
      V_IDTPLANCTO   := '4';
      V_IDENTRSAIDOP := 'S';

      IF P_IDTIPOTRANSF = 'SR' THEN
         V_IDTIPOMOVI   := '3';
      ELSE
         V_IDTIPOMOVI   := '4';
      END IF;
   END IF;

   INSERT INTO LANCTOESTOQ
      (CDFILIAL, NRLANCESTQ, IDTPLANCTO, DTLANCESTQ,
       DSLANCESTQ, CDFILIMOVI, IDENTRSAIDOP)
   VALUES
      (P_CDFILIALMAP, P_PRXLANCESTQ, V_IDTPLANCTO, P_DTMAPABASEV,
       'Venda '||P_NRVENDA||' Mapa '||P_NRMAPABASEV, P_CDFILIAL, V_IDENTRSAIDOP);

   V_NRSEQITEM := 1;
   IF P_IDTIPOEQUIPA = '0' THEN
      /*********************************************************************/
      /* LANAMENTO PARA OS ITENS DO MAPA                                  */
      FOR C_ITEMAPA IN
        (SELECT
            I.CDITMAPABAS,  I.CDPRODUTO   , I.QTABASITMAPA, I.QTFREPITMAPA, I.QTSALDITMAPA,
            I.VRPRITEMMAP,  I.VRPRITEMCMAP, I.CDPRODORIGTR, I.QTPERDITMAPA, I.QTRETIITMAPA,
            I.QTVENDITMAPA, I.QTFATUITMAPA, I.QTTESTITMAPA, I.CDTIPORETI,   P.CDPRODESTO,
            P.VRFATOCONV
         FROM PRODUTO P, ITEMAPABASEV I
         WHERE I.CDFILIAL    = P_CDFILIALMAP
           AND I.NRMAPABASEV = P_NRMAPABASEV
           AND P.CDPRODUTO   = I.CDPRODUTO) LOOP

         V_CDTIPORETI := '';
         V_CDTIPOOPER := '';
         V_IDGERAITEM := 'S';
         IF (P_IDTIPOTRANSF = 'EA') OR (P_IDTIPOTRANSF = 'SA') THEN
            V_IDLESTRECMAP := 'A';
            V_QTPRODVEND   := C_ITEMAPA.QTABASITMAPA * C_ITEMAPA.VRFATOCONV;
         ELSE
            V_IDLESTRECMAP := 'P';
            V_QTPRODVEND   := C_ITEMAPA.QTRETIITMAPA * C_ITEMAPA.VRFATOCONV;

            /* VERIFICA SE A RETIRADA  DE DEVOLUCAO */
            V_CDTIPORETI   := C_ITEMAPA.CDTIPORETI;
            SELECT CDTIPORETIDE INTO V_CDTIPORETIDE
            FROM PARGERALVMN;

            IF V_CDTIPORETIDE = V_CDTIPORETI THEN
               IF P_IDTIPOTRANSF = 'SR' THEN
                  V_CDTIPOOPER := '13';
               END IF;
            ELSE
               V_IDGERAITEM := 'N';
            END IF;
         END IF;

         IF (V_QTPRODVEND > 0)   AND
            (V_IDGERAITEM = 'S') THEN

            IF (P_IDTIPOTRANSF = 'EA') OR (P_IDTIPOTRANSF = 'ER') THEN
               V_VRCUSTOPROD  := CUSTO_PROD(P_CDFILIORIG, C_ITEMAPA.CDPRODESTO, 1,
                                            P_DTMAPABASEV, P_CDALMOXORIG, P_CDLOCALORIG);
            ELSE
               V_VRCUSTOPROD  := 0;
            END IF;

            INSERT INTO ITLANCTOEST
               (CDFILIAL,     NRLANCESTQ,  NRSEQUITEM,
                CDPRODUTO,    QTLANCTOEST, QTTOTLANCTO,
                CDPRODMOVI,   CDFILIMOVI,  CDALMOXARIFE,
                CDLOCALESTOQ, NRLOTEESTQ,  NRSUBLOTE,
                IDENTRSAIDOP, CDTIPORETI,  CDTIPOOPER,
                CDOPERADOR,   IDTIPOMOVI,  VRUNILANCTO,   VRTOTLANCTO)
            VALUES
               (P_CDFILIALMAP, P_PRXLANCESTQ, LPAD(TO_CHAR(V_NRSEQITEM), 4, '0'),
                C_ITEMAPA.CDPRODUTO,  V_QTPRODVEND, V_QTPRODVEND,
                C_ITEMAPA.CDPRODESTO, P_CDFILIAL,   P_CDALMOXARIFE,
                P_CDLOCALESTOQ, ' ', ' ',
                V_IDENTRSAIDOP, V_CDTIPORETI, V_CDTIPOOPER,
                P_CDOPERADOR,   V_IDTIPOMOVI, V_VRCUSTOPROD, V_QTPRODVEND * V_VRCUSTOPROD);

            INSERT INTO LANCESTITMAP
               (CDFILIAL, NRMAPABASEV, CDITMAPABAS,
                CDFILIMOVI, NRLANCESTQ, NRSEQUITEM,
                IDLESTITMAP)
            VALUES
               (P_CDFILIALMAP, P_NRMAPABASEV, C_ITEMAPA.CDITMAPABAS,
                P_CDFILIALMAP, P_PRXLANCESTQ, LPAD(TO_CHAR(V_NRSEQITEM), 4, '0'),
                V_IDLESTRECMAP);

            V_NRSEQITEM := V_NRSEQITEM + 1;
         END IF;
      END LOOP;
   ELSE
      /*********************************************************************/
      /* LANAMENTO PARA A COMPOSIO DOS ITENS DO MAPA                    */
      FOR C_RECITEMAPA IN
         (SELECT R.CDPRODUTO,  R.QTABASITREC, R.QTPERDITREC, R.CDTIPORETI,
                 P.CDPRODESTO, P.VRFATOCONV
          FROM PRODUTO P, RECITEMAPABA R
          WHERE (CDFILIAL    = P_CDFILIALMAP)
            AND (NRMAPABASEV = P_NRMAPABASEV)
            AND (P.CDPRODUTO = R.CDPRODUTO)) LOOP

         V_CDTIPORETI := '';
         V_CDTIPOOPER := '';
         V_IDGERAITEM := 'S';
         IF (P_IDTIPOTRANSF = 'EA') OR (P_IDTIPOTRANSF = 'SA') THEN
            V_IDLESTRECMAP := 'A';
            V_QTPRODVEND   := C_RECITEMAPA.QTABASITREC * C_RECITEMAPA.VRFATOCONV;
         ELSE
            V_IDLESTRECMAP := 'P';
            V_QTPRODVEND   := C_RECITEMAPA.QTPERDITREC * C_RECITEMAPA.VRFATOCONV;

            /* VERIFICA SE A RETIRADA  DE DEVOLUCAO */
            V_CDTIPORETI := C_RECITEMAPA.CDTIPORETI;
            SELECT CDTIPORETIDE INTO V_CDTIPORETIDE
            FROM PARGERALVMN;

            IF V_CDTIPORETIDE = V_CDTIPORETI THEN
               IF P_IDTIPOTRANSF = 'SR' THEN
                  V_CDTIPOOPER := '13';
               END IF;
            ELSE
               V_IDGERAITEM := 'N';
            END IF;
         END IF;

         IF (V_QTPRODVEND > 0)   AND
            (V_IDGERAITEM = 'S') THEN

            IF (P_IDTIPOTRANSF = 'EA') OR (P_IDTIPOTRANSF = 'ER') THEN
               V_VRCUSTOPROD  := CUSTO_PROD(P_CDFILIORIG, C_RECITEMAPA.CDPRODESTO, 1,
                                            P_DTMAPABASEV, P_CDALMOXORIG, P_CDLOCALORIG);
            ELSE
               V_VRCUSTOPROD  := 0;
            END IF;

            INSERT INTO ITLANCTOEST
               (CDFILIAL,     NRLANCESTQ,  NRSEQUITEM,
                CDPRODUTO,    QTLANCTOEST, QTTOTLANCTO,
                CDPRODMOVI,   CDFILIMOVI,  CDALMOXARIFE,
                CDLOCALESTOQ, NRLOTEESTQ,  NRSUBLOTE,
                IDENTRSAIDOP, CDTIPORETI,  CDTIPOOPER,
                CDOPERADOR,   IDTIPOMOVI,  VRUNILANCTO,    VRTOTLANCTO)
            VALUES
               (P_CDFILIALMAP, P_PRXLANCESTQ, LPAD(TO_CHAR(V_NRSEQITEM), 4, '0'),
                C_RECITEMAPA.CDPRODUTO,  V_QTPRODVEND, V_QTPRODVEND,
                C_RECITEMAPA.CDPRODESTO, P_CDFILIAL,   P_CDALMOXARIFE,
                P_CDLOCALESTOQ, ' ', ' ',
                V_IDENTRSAIDOP, V_CDTIPORETI, V_CDTIPOOPER,
                P_CDOPERADOR,   V_IDTIPOMOVI, V_VRCUSTOPROD, V_QTPRODVEND * V_VRCUSTOPROD);

            INSERT INTO LANCESTRECMA
               (CDFILIAL,   NRMAPABASEV, CDPRODUTO,
                CDFILIMOVI, NRLANCESTQ,  NRSEQUITEM,
                IDLESTRECMAP)
            VALUES
               (P_CDFILIALMAP, P_NRMAPABASEV, C_RECITEMAPA.CDPRODUTO,
                P_CDFILIALMAP, P_PRXLANCESTQ, LPAD(TO_CHAR(V_NRSEQITEM), 4, '0'),
                V_IDLESTRECMAP);

            V_NRSEQITEM := V_NRSEQITEM + 1;
         END IF;
      END LOOP;
   END IF;

   SELECT COUNT(*) INTO V_CTITELANCTO
   FROM ITLANCTOEST
   WHERE CDFILIAL   = P_CDFILIALMAP
     AND NRLANCESTQ = P_PRXLANCESTQ;

   IF V_CTITELANCTO = 0 THEN
      DELETE FROM LANCTOESTOQ
      WHERE CDFILIAL   = P_CDFILIALMAP
        AND NRLANCESTQ = P_PRXLANCESTQ;
   ELSE
      IF SYSDATE > P_DTMAPABASEV THEN
         V_DTFINAL := SYSDATE;
      ELSE
         V_DTFINAL := P_DTMAPABASEV;
      END IF;
      ATUALIZA_ESTOQUE(P_CDFILIAL, P_DTMAPABASEV, V_DTFINAL, P_CDFILIALMAP, P_PRXLANCESTQ);
   END IF;
END;
/
